#
# spec file for package nvme-cli
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           nvme-cli
Version:        1.5
Release:        lp150.6.16.1
Summary:        NVM Express user space tools
License:        GPL-2.0-only
Group:          Hardware/Other
Url:            https://github.com/linux-nvme/nvme-cli
Source:         %{name}-v%{version}.tar.gz
Source2:        nvme-cli-rpmlintrc
BuildRequires:  asciidoc
BuildRequires:  libuuid-devel
BuildRequires:  xmlto
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(udev)
%ifarch x86_64 aarch64 i586
Requires(post): dmidecode
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Patch1:         0001-nvme-cli-add-NetApp-plugin.patch
Patch2:         0002-nvme-cli-add-netapp-smdevices-man-page.patch
Patch3:         0003-get-log-Make-log-identifier-a-required-parameter.patch
Patch4:         0004-Documentation-add-manpage-entry-for-connect-s-ctrl-l.patch
Patch5:         0005-fabrics-add-option-to-supply-keep-alive-timeout-for.patch
Patch6:         0006-fabrics-add-ctrl-loss-tmo-to-connect-all.patch
Patch7:         0007-nvme-vendor-Add-get-log-LSP-LSO-fields-from-1.3-spec.patch
Patch8:         0008-nvme-cli-Implement-nvme_get_log13.patch
Patch9:         0009-nvme-cli-Add-support-of-unsigned-long-long-to-json-r.patch
Patch10:        0010-nvme-cli-add-support-of-RAE.patch
Patch11:        0011-nvme-cli-add-minimal-ana-log-page-support.patch
Patch12:        0012-nvme-cli-add-ana-log-documentation.patch
Patch13:        0013-nvme-discover-sanitize-options.patch
Patch14:        0014-Fix-double-free-in-list_subsys.patch
Patch15:        0015-Log-error-incase-of-failure-in-get_nvme_subsystem_in.patch
Patch16:        0016-nvme-cli-move-print-function-to-nvme-print.patch
Patch17:        0017-nvme-cli-show-partial-results-if-controller-fails-du.patch
Patch19:        0019-nvme-discover-Retry-discovery-log-if-the-generation-.patch
Patch20:        0020-nvme-cli-fabrics-Fix-passing-host_traddr-for-all-tra.patch
Patch21:        0021-fabrics-write-ctrl_loss_tmo-to-fabrics-device-on-con.patch
Patch22:        0022-fabrics-write-keep-alive-timeout-to-fabrics-device-o.patch
Patch23:        0023-Fix-print-format-specifier-for-64-bit.patch
Patch24:        0024-nvme-ana-log-fixup-compiler-warning-in-show_ana_log.patch
Patch25:        0025-fabrics-make-some-arguments-integers.patch
Patch26:        0026-fabrics-don-t-fail-empty-discovery-log-page.patch
Patch27:        0027-nvme-commonize-subsystems-info-in-a-helper.patch
Patch28:        0028-nvme-ioctl-retrieve-log-pages-in-4k-chunks.patch
Patch29:        0029-nvme-discover-Re-check-generation-counter-after-log-.patch
Patch30:        0030-nvme-fixup-ANA-group-descriptor-offset.patch
Patch31:        0031-nvme-introduce-get_nvme_ctrl_attr.patch
Patch32:        0032-nvme-print-out-controller-state-for-list-subsys.patch
Patch33:        0033-nvme-list-subsys-Add-device-name-argument-and-print-.patch
Patch34:        0034-fabrics-allow-nr_io-write-poll_queues-and-queue-size.patch
Patch35:        0035-fabrics-do-not-use-queue_size-and-nr_io_queues-for-d.patch
Patch36:        0036-fabrics-mask-out-invalid-options-during-discovery.patch
Patch37:        0037-nvme-Document-Q-and-i-for-discovery-and-connect-all.patch
Patch38:        0038-nvme-cli-add-netapp-ontapdevices-command.patch
Patch39:        0039-nvme-cli-add-netapp-ontapdevices-man-page.patch
Patch40:        0040-nvme-cli-Increase-size-of-ONTAP-namespace-path-varia.patch
Patch41:        0041-nvme-vendor-fixup-c99-declaration-in-huawei-plugin.patch
Patch42:        0042-nvme-cli-fix-fc-trtype-string.patch
Patch43:        0043-flush-Use-device-NSID-if-issuing-through-block-devic.patch
Patch100:       0100-nvme_fc-auto-connect-scripts.patch
Patch101:       0101-71-nvme-iopolicy-netapp.rules-add-default-rules-for-.patch
Patch102:       0102-Add-nvmefc-connect.target.patch
Patch103:       0103-Change-service-to-type-simple.patch
Patch104:       0104-nvme-cli-Fix-documentation-syntax-and-typo.patch
Patch105:       0105-nvme-cli-Check-for-sysfs-interface-before-NVMe-disco.patch
Patch106:       0106-nvme-cli-Update-nvme-connect-all-man-page.patch
Patch107:       0107-nvme-cli-add-default-IO-policy-rule-for-NetApp-E-Ser.patch
Patch108:       0108-nvme-cli-Rename-udev-rule-for-ONTAP-controller.patch
Patch109:       0109-nvme-cli-Add-script-to-determine-host-NQN.patch

%description
NVM Express (NVMe) is a direct attached storage interface. The
nvme-cli package contains core management tools with minimal
dependencies.

%package -n     nvme-cli-regress-script
Summary:        A small script to test the nvme binary for regressions
Group:          Hardware/Other
Requires:       nvme-cli

%description -n nvme-cli-regress-script
A small shell script to test the nvme binary for regressions. It requires an
NVMe device for testing purposes. Do NOT use in a production environment.

%prep
%setup -q -n %{name}-v%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1

%build
echo %{version} > version
make CFLAGS="%{optflags}" PREFIX=%{_prefix} %{?_smp_mflags} all
# nvme-cli-regress-script subpackage: remove make and install steps
sed -i '/make.*/d' regress

%install
make PREFIX=%{_prefix} DESTDIR=%{buildroot} install-bin install-man %{?_smp_mflags}
install -m 644 -D /dev/null %{buildroot}%{_sysconfdir}/nvme/hostnqn
install -m 644 -D completions/bash-nvme-completion.sh %{buildroot}%{_datadir}/bash_completion/completions/nvme
install -m 644 -D nvme-fc-autoconnect/70-nvmefc-autoconnect.rules %{buildroot}%{_udevrulesdir}/70-nvmefc-autoconnect.rules
install -m 644 -D nvme-fc-autoconnect/nvmefc-boot-connections.service %{buildroot}%{_unitdir}/nvmefc-boot-connections.service
install -m 644 -D nvme-fc-autoconnect/nvmefc-connect@.service %{buildroot}%{_unitdir}/nvmefc-connect@.service
install -m 644 -D nvme-fc-autoconnect/nvmefc-connect.target %{buildroot}%{_unitdir}/nvmefc-connect.target
install -m 644 -D scripts/71-nvme-iopolicy-netapp-ONTAP.rules %{buildroot}%{_udevrulesdir}/71-nvme-iopolicy-netapp-ONTAP.rules
install -m 644 -D scripts/71-nvme-iopolicy-netapp-E-Series.rules %{buildroot}%{_udevrulesdir}/71-nvme-iopolicy-netapp-E-Series.rules
%ifarch x86_64 aarch64 i586
install -m 744 -D scripts/det-hostnqn.sh %{buildroot}%{_sbindir}/nvme-det-hostnqn
%endif
# for subpackage nvme-cli-regress-script:
install -m 744 -D regress %{buildroot}%{_sbindir}/nvme-regress

%define services nvmefc-boot-connections.service nvmefc-connect.target

%pre
%service_add_pre %services nvmefc-connect@.service

%post
%ifarch x86_64 aarch64 i586
if [ ! -s %{_sysconfdir}/nvme/hostnqn ]; then
	%{_sbindir}/nvme-det-hostnqn > %{_sysconfdir}/nvme/hostnqn
fi
%endif
if [ ! -s %{_sysconfdir}/nvme/hostnqn ]; then
	%{_bindir}/echo "Generating random host NQN."
	%{_sbindir}/nvme gen-hostnqn > %{_sysconfdir}/nvme/hostnqn
fi
if [ ! -s %{_sysconfdir}/nvme/hostid ]; then
	%{_bindir}/uuidgen > %{_sysconfdir}/nvme/hostid
fi
%service_add_post %services nvmefc-connect@.service

%preun
%service_del_preun -f %services

%postun
%service_del_postun %services

%posttrans
if [ -f /sys/class/fc/fc_udev_device/nvme_discovery ]; then
	%{_bindir}/echo add > /sys/class/fc/fc_udev_device/nvme_discovery
fi

%files
%defattr(-,root,root)
%doc README.md LICENSE
%{_sbindir}/nvme
%ifarch x86_64 aarch64 i586
%{_sbindir}/nvme-det-hostnqn
%endif
%{_mandir}/man1/nvme*.1*
%dir %{_sysconfdir}/nvme/
%dir %{_datadir}/bash_completion
%dir %{_datadir}/bash_completion/completions/
%{_datadir}/bash_completion/completions/nvme
%{_udevrulesdir}/70-nvmefc-autoconnect.rules
%{_udevrulesdir}/71-nvme-iopolicy-netapp-ONTAP.rules
%{_udevrulesdir}/71-nvme-iopolicy-netapp-E-Series.rules
%{_unitdir}/nvmefc-boot-connections.service
%{_unitdir}/nvmefc-connect@.service
%{_unitdir}/nvmefc-connect.target
%ghost %{_sysconfdir}/nvme/hostnqn
%ghost %{_sysconfdir}/nvme/hostid

%files -n nvme-cli-regress-script
%{_sbindir}/nvme-regress

%changelog
* Fri May 17 2019 Simon Schricker <sschricker@suse.com>
- Add script to determine host NQN based on the system UUID
  + 0109-nvme-cli-Add-script-to-determine-host-NQN.patch
- Update man page of nvme connect-all to list new flags.
  (bsc#1084379)
  + 0106-nvme-cli-Update-nvme-connect-all-man-page.patch
- Add new udev rule for NetApp E-Series and adjust udev rule naming
  scheme accordingly. (bsc#1124564)
  + 0107-nvme-cli-add-default-IO-policy-rule-for-NetApp-E-Ser.patch
  + 0108-nvme-cli-Rename-udev-rule-for-ONTAP-controller.patch
* Tue May 14 2019 Simon Schricker <sschricker@suse.com>
- Nvme flush now determines the namespace id, when not given via -n
  flag. This also fixes a failing test in the regress-script.
  + 0043-flush-Use-device-NSID-if-issuing-through-block-devic.patch
* Thu May  9 2019 Simon Schricker <sschricker@suse.com>
- remove c99 declaration to be compatible with older compilers.
  + 0041-nvme-vendor-fixup-c99-declaration-in-huawei-plugin.patch
- rename transport type to bring the discovery log more in line
  with the code, see discussion at (bsc#1126565)
  + 0042-nvme-cli-fix-fc-trtype-string.patch
* Mon May  6 2019 Simon Schricker <sschricker@suse.com>
- Increase size of ONTAP namespace path variable
  + 0040-nvme-cli-Increase-size-of-ONTAP-namespace-path-varia.patch
- Fix failing service on devices without fc-hardware (bsc#1133594)
  + 0105-nvme-cli-Check-for-sysfs-interface-before-NVMe-disco.patch
* Thu Apr 11 2019 Simon Schricker <sschricker@suse.com>
- Add new 'ontapdevices' command and corresponding documentation.
  Requested in (bsc#1131930).
  + 0038-nvme-cli-add-netapp-ontapdevices-command.patch
  + 0039-nvme-cli-add-netapp-ontapdevices-man-page.patch
  + 0104-nvme-cli-Fix-documentation-syntax-and-typo.patch
* Wed Mar 13 2019 Simon Schricker <sschricker@suse.com>
- Add nvmefc-connect.target to allow stopping the parameterized
  services (bsc#1127076). Also change the service type so udevd
  doesn't have to wait for the termination of the service process.
  + 0102-Add-nvmefc-connect.target.patch
  + 0103-Change-service-to-type-simple.patch
* Tue Feb 12 2019 hare@suse.de
- fabrics: allow nr_io/write/poll_queues and queue size to discovery
  (bsc#1084379)
  + 0034-fabrics-allow-nr_io-write-poll_queues-and-queue-size.patch
- fabrics: do not use 'queue_size' and 'nr_io_queues' for discovery
  controller (bsc#1111286)
  + 0035-fabrics-do-not-use-queue_size-and-nr_io_queues-for-d.patch
- fabrics: mask out invalid options during discovery (bsc#1111286)
  + 0036-fabrics-mask-out-invalid-options-during-discovery.patch
- nvme: Document '-Q' and '-i' for discovery and connect-all
  + 0037-nvme-Document-Q-and-i-for-discovery-and-connect-all.patch
- Add 71-nvme-iopolicy-netapp.rules (bsc1124564)
  + 0101-71-nvme-iopolicy-netapp.rules-add-default-rules-for-.patch
* Fri Jan 18 2019 hare@suse.de
- Add FC-NVMe autoconnect scripts (bsc#1103354)
  + 0100-nvme_fc-auto-connect-scripts.patch
* Thu Nov  8 2018 hare@suse.de
- Refresh patch with mainline version
  + 0019-nvme-discover-Retry-discovery-log-if-the-generation-.patch
- Fix print format specifier for 64-bit (bsc#1113400)
  + 0023-Fix-print-format-specifier-for-64-bit.patch
- nvme-ana-log: fixup compiler warning in show_ana_log() (bsc#1113400)
  + 0024-nvme-ana-log-fixup-compiler-warning-in-show_ana_log.patch
- fabrics: make some arguments integers (bsc#1113400)
  + 0025-fabrics-make-some-arguments-integers.patch
- fabrics: don't fail empty discovery log page (bsc#1105314)
  + 0026-fabrics-don-t-fail-empty-discovery-log-page.patch
- nvme: commonize subsystems info in a helper (bsc#1105314)
  + 0027-nvme-commonize-subsystems-info-in-a-helper.patch
- nvme-ioctl: retrieve log pages in 4k chunks (bsc#1105314)
  + 0028-nvme-ioctl-retrieve-log-pages-in-4k-chunks.patch
- nvme-discover: Re-check generation counter after log page transfer
  (bsc#1105314)
  + 0029-nvme-discover-Re-check-generation-counter-after-log-.patch
- nvme: fixup ANA group descriptor offset (bsc#1111384)
  + 0030-nvme-fixup-ANA-group-descriptor-offset.patch
- nvme: introduce get_nvme_ctrl_attr() (bsc#1113400)
  + 0031-nvme-introduce-get_nvme_ctrl_attr.patch
- nvme: print out controller state for 'list-subsys' (bsc#1113400)
  + 0032-nvme-print-out-controller-state-for-list-subsys.patch
- Update 'nvme-list-subsys: Add device name argument and print ANA
  state'
  - 0018-nvme-list-subsys-Add-device-name-argument-and-print-.patch
  + 0033-nvme-list-subsys-Add-device-name-argument-and-print-.patch
* Fri Aug 10 2018 hare@suse.de
- nvme-discover: Retry discovery log if the generation counter changes
  (bsc#1087848)
  + 0019-nvme-discover-Retry-discovery-log-if-the-generation-.patch
- nvme-fabrics: Fix passing "host_traddr" for all transports (bsc#1084379)
  + 0020-nvme-cli-fabrics-Fix-passing-host_traddr-for-all-tra.patch
- fabrics: write ctrl_loss_tmo to fabrics device on connect (bsc#1084379)
  + 0021-fabrics-write-ctrl_loss_tmo-to-fabrics-device-on-con.patch
- fabrics: write keep-alive-timeout to fabrics device on connect (bsc#1090568)
  + 0022-fabrics-write-keep-alive-timeout-to-fabrics-device-o.patch
* Tue Aug  7 2018 hare@suse.de
- nvme-vendor: Add get_log LSP & LSO fields from 1.3 spec
  (bsc#1099018)
  + 0007-nvme-vendor-Add-get-log-LSP-LSO-fields-from-1.3-spec.patch
- nvme-cli: Implement nvme_get_log13 (bsc#1099018)
  + 0008-nvme-cli-Implement-nvme_get_log13.patch
- nvme-cli: Add support of unsigned long long to json (bsc#1099018)
  + 0009-nvme-cli-Add-support-of-unsigned-long-long-to-json-r.patch
- nvme-cli: add support of RAE (bsc#1099018)
  + 0010-nvme-cli-add-support-of-RAE.patch
- nvme-cli: add minimal ana-log page support (bsc#1099018)
  + 0011-nvme-cli-add-minimal-ana-log-page-support.patch
- nvme-cli: add ana_log documentation (bsc#1099018)
  + 0012-nvme-cli-add-ana-log-documentation.patch
- nvme-discover: sanitize options
  + 0013-nvme-discover-sanitize-options.patch
- Fix double free in list_subsys
  + 0014-Fix-double-free-in-list_subsys.patch (bsc#1099018)
- Log error in case of failure in get_nvme_subsystem (bsc#1099018)
  + 0015-Log-error-incase-of-failure-in-get_nvme_subsystem_in.patch
- nvme-cli: move print function to nvme-print.c (bsc#1099018)
  + 0016-nvme-cli-move-print-function-to-nvme-print.patch
- nvme-cli: show partial results if controller fails (bsc#1099018)
  + 0017-nvme-cli-show-partial-results-if-controller-fails-du.patch
- nvme-list-subsys: Add device name argument and print ANA state
  (bsc#1099018)
  + 0018-nvme-list-subsys-Add-device-name-argument-and-print-.patch
* Thu Jun  7 2018 jthumshirn@suse.com
- Add ctrl-loss-tmo to connect-all command (bsc#1084379)
  + 0006-fabrics-add-ctrl-loss-tmo-to-connect-all.patch
* Wed May  2 2018 jthumshirn@suse.com
- Add keep-alive-tmo option to connect-all command (bsc#1090568)
  + 0005-fabrics-add-option-to-supply-keep-alive-timeout-for.patch
* Thu Apr 12 2018 jthumshirn@suse.com
- Add ctrl-loss-tmo option to fabrics connect manpage (bsc#1084379)
  + 0004-Documentation-add-manpage-entry-for-connect-s-ctrl-l.patch
* Wed Apr  4 2018 jthumshirn@suse.com
- Make log identifier a required parameter (bsc#1086240)
  + 0003-get-log-Make-log-identifier-a-required-parameter.patch
* Tue Feb 13 2018 jthumshirn@suse.com
- Add NetApp vendor plugin (bsc#1080672)
  + 0001-nvme-cli-add-NetApp-plugin.patch
  + 0002-nvme-cli-add-netapp-smdevices-man-page.patch
* Wed Jan 10 2018 jthumshirn@suse.com
- Update to version v1.5 (FATE#322735):
  * Remove upstreamed patches:
  - 0001-nvme-Introduce-new-list-subsys-command.patch
  - 0009-fabrics-also-set-queue_size-and-nr_io_queues-on-conn.patch
  * fabrics: also set queue_size and nr_io_queues on connect-all connects
  * nvme-cli: add duplicate_connect parameter support
  * nvme-cli : wdc-plugin Add support for WDC SN100 and SN200 devices.
  * Add AEN decoder helper to get-log
  * Regen documentation
  * Add Nix(OS) install instructions to the README
  * Fix the Markdown code for the Alpine install instructions
  * nvme-cli: make address print format more human-readable
  * intel-nvme: Fix compiler errors and warnings
  * Include sizing data in json output that's already included in the non-json results.
  * Cleanup variable definitions
  * Add command effects log page
  * Increase default format timeout
  * Revert "nvme-cli: add duplicate_connect parameter support"
  * nvme-cli: add duplicate_connect parameter support
  * nvme-cli: fix wrong bitmask in number of rpmb units.
  * nvme-cli: make command description const
  * nvme/id-ns: do not try to get namespace id from non-block device.
  * Fix typo in previous commit
  * Fix long suffix parse on 32-bit machines
  * Nitpicked a printing alignment issue with the id-ns vendor specific field
  * Avoid unnecessary abbreviation.
  * nvme/flush: explicitely close file descriptor
  * Fix memory leak
  * Add 'DEAC' support to write-zeroes command
  * Rebuild documentation
  * nvme-cli: resync nvme.h with the kernel's
  * NVMe-CLI : WDC-Plugin Updated Smart Log Command
  * NVMe-CLI : WDC-Plugin Documentation for Updated Smart Log Command
  * Regenerate documentation
  * nvme-cli: update show_registers_cc() to use nvme.h
  * nvme-cli: replace values of all namespaces with NVME_NSID_ALL
  * nvme-cli: add prints for new HMB identify fields of TP 4002
  * Update get-feature help text
  * Improve code alignment on intel plugin
  * Update intel internal log man page.
  * nvme-cli/intel: Return if arg parsing returns error
  * nvme: add options for write command directives
  * Update documentation
  * Updated the human readable printing for the SGLS field in the id-ctrl command to be compliant with NVMe 1.3
  * nvme: Introduce new 'list-subsys' command
  * nvme-cli: add support to get properties for NVMe over Fabric
  * nvme-cli: support to set the property for NVMe over Fabric
  * Reorder command list
  * Documentation fixes
  * nvme-cli: add support alias command with Firmware Activate
  * nvme-cli: update Firmware Commit with boot partition feature
  * nvme-cli: add command specific status of Firmware Commit
  * Update documentation to use aliases
  * nvme-cli: add prints of boot partition feature to show-regs
  * nvme-cli: Fix small mem leak.
  * Release v1.5
* Thu Dec 14 2017 jthumshirn@suse.com
- Add list-subs subcommand (bsc#1072813)
  + 0001-nvme-Introduce-new-list-subsys-command.patch
* Tue Oct 24 2017 jengelh@inai.de
- Update descriptions.
* Wed Oct 18 2017 jthumshirn@suse.com
- Update to version v1.4 (FATE#322735):
  * Fixup Security send/recv to read data from disk
  * Unbreak RPM build after bash completion files were moved in 7e4c7596
  * fabrics: Fix disconnect_by_device from disconnecting instance 0 on error
  * lightnvm: allow to init target on factory mode
  * Fixed problem with security-recv binary output not working correctly
  * nvme-cli: return 0 if disconnect operation with cfg.nqn successfully
  * Fix compile for 32-bit
  * nvme-cli: Fix build on aarch64-linux-android-4.9
  * nvme-cli: Huawei plug-in.
  * nvme-print: Fix line spacing on -H option
  * id-ctrl: remove new lines from json output
  * nvme-list: print empty lists when no devices are present
  * fabrics: add option to override drivers queue depth
  * nvme-cli: nvme-intel implement json output for smart-log
  * nvme-cli: Add parsing support for noiob
  * Fix potential device string truncation
  * fabrics: add option to override drivers queue depth also for connect-all command
  * Regenerate man-pages
  * Release v1.3
  * nvme-print: Free only top-level json objects
  * fix use-after-free in pci.ids parsing
  * nvme-cli: add fields into identify controller data structure
  * nvme-cli: show more fields for id-ctrl
  * nvme-cli: id-ctrl: display additional fields
  * Show help when no or an invalid device is given
  * nvme-cli: add id-ctrl for nvme-huawei plug-in.
  * Fix spelling errors
  * fabrics: add hostid option to connect command
  * nvme-cli: add ns-descs subcommand
  * nvme-cli: Get Feature support for Extended Host Id
  * nvme-cli: Fix typo in Intel plugin and improve generic help text
  * Implement Intel Vendor specific logs
  * nvme-cli: add thermal management fields for smart-log
  * nvme-cli: add temperature sensor fields in json_smart_log
  * nvme-cli: add output-format discription for smart-log
  * Formatting update
  * Regenerate documentation
  * nvme-cli: add error message for nvme list.
  * Fix typo of flbas in nvme_create_max_ns_test
  * Show help for get-ns-id
  * Show help for nvme reset and subsystem-reset
  * nvme-cli: Extended Data Structure in resv-report
  * Update docs
  * resync nvme.h with the kernel nvme.h
  * nvme-cli : add support for sanitize command.
  * nvme-cli : add sanitize command documentation.
  * nvme-cli : add support for retrieving sanitize log.
  * nvme-cli : add sanitize-log command documentation.
  * fix build without libuuid
  * nvme-cli : wdc-plug-in : return on invalid input device.
  * nvme-cli : only print help text and return for nvme list -h option.
  * nvme-cli/list-ns: fix identifying active or allocated namespaces list
  * Fixed get_internal_log to parse the entire nlog and allow selection of specific regions to be parsed.
  * NVMe-CLI Fix Sanitize Command Parameter Types
  * Fix app tag and mask setting
  * Fix app tag field sizes
  * nvme-cli/list: fix when nvme device can not be open
  * nvme-cli/list: change fd returned by open operation from unsigned to signed.
  * Makefile: allow linker override for cross uuid test
  * nvme-cli: fix connecting failure due to invalid uuid format of hostid
  * nvme-cli/fabrics: Add ctrl-loss-tmo param to connect cmd
  * Fixing macro definitions to avoid issues when these are used in expressions
  * nvme-cli: add nvme directive command support
  * nvme-cli: add documentation for directive commands
  * fix for issue 219, show-regs reports AQA.ACQS and AQA.ASQS as bytes
  * nvme-cli: Fix nvme ns desc
  * new bit fields (6, 7, and 8) for OACS from NVMe rev 1.3
  * added new bit field (6) to ONCS from NVMe rev 1.3
  * nvme-cli: Describe action 3 of nvme activate
  * nvme-cli: generate spec-compliant UUID NQNs
  * NVMe-CLI Fixed Status Code check for reset type on fw-activate.
  * Added handling for temperature threshold values below 0C(273K) and removed buffer check for human readable output as Temperature threshold feature does not use Memory Buffer for Attributes
  * Update nvme.c
  * nvme-cli : Add Namespace Rescan Command
  * nvme-cli : Add man documentation files for ns-rescan command.
  * Version 1.4 Release
  * Drop upstream patches:
  - 0001-fabrics-add-option-to-override-drivers-queue-depth.patch
  - 0002-fabrics-add-option-to-override-drivers-queue-depth-a.patch
  - add-missing-nvme_id_crtl-fileds.patch
  - 0003-nvme-cli-show-more-fields-for-id-ctrl.patch
  - 0004-nvme-cli-id-ctrl-display-additional-fields.patch
  - 0005-nvme-cli-add-ns-descs-subcommand.patch
  - 0006-fabrics-add-hostid-option-to-connect-command.patch
  - 0007-nvme-cli-fix-connecting-failure-due-to-invalid-uuid-format.patch
  - 0008-nvme-cli-generate-spec-compliant-uuid-nqns.patch
* Tue Oct 17 2017 jthumshirn@suse.com
- allow override queue depth and nr io queues on connect-all (bsc#1063462)
  + 0009-fabrics-also-set-queue_size-and-nr_io_queues-on-conn.patch
* Thu Sep  7 2017 jthumshirn@suse.com
- Generate Spec compliant UUID NQNs (bsc#1057498)
  + 0008-nvme-cli-generate-spec-compliant-uuid-nqns.patch
* Thu Aug 31 2017 jthumshirn@suse.com
- Fix hostid parsing (bsc#1049272)
  + 0007-nvme-cli-fix-connecting-failure-due-to-invalid-uuid-format.patch
* Fri Jun 30 2017 jthumshirn@suse.com
- Add hostid option to connect command (bsc#1045293)
  + 0006-fabrics-add-hostid-option-to-connect-command.patch
* Mon Jun 26 2017 jthumshirn@suse.com
- Create nvme files and directories in /etc/nvme (bsc#1045931 )
* Mon Jun 26 2017 jthumshirn@suse.com
- Provide nvme ns-descs subcommand (bsc#1038235)
  + 0005-nvme-cli-add-ns-descs-subcommand.patch
* Fri Jun 16 2017 jthumshirn@suse.com
-  Also re-build documentation on each build (bsc#1037297)
* Wed Jun 14 2017 jthumshirn@suse.com
- Add NVMe over Fabrics specific id-ctrl fields (bsc#1037293)
  + add-missing-nvme_id_crtl-fileds.patch
  + 0003-nvme-cli-show-more-fields-for-id-ctrl.patch
  + 0004-nvme-cli-id-ctrl-display-additional-fields.patch
* Fri May 12 2017 jthumshirn@suse.com
- Add possibility to change queue depth at connect time (bsc#1037297)
  + 0001-fabrics-add-option-to-override-drivers-queue-depth.patch
  + 0002-fabrics-add-option-to-override-drivers-queue-depth-a.patch
* Mon Apr 24 2017 jthumshirn@suse.com
- Update to version v1.2 (FATE#322735 ,bsc#1033410):
  * Include endian.h for byte/host order functions
  * nvme-cli: Add nvme hostnqn generation option
  * nvme.spec/debian: Auto generate host nqn as part of install
  * Documentation: Add entry for gen-hostnqn
  * Regenerate Documentation
  * Fix read/write man pages
  * get-features: Don't try to read the data buffer for sel == 3
  * Documentation: fix location of device reset
  * Regen documentation
  * Remove debian/ directory
  * Remove pyc files generated by 'make test'
  * Moving the bash completion files to the standard
  * lightnvm: default to -1 on lun begin and end
  * nvme-cli: fabrics: Fix to pass "host_traddr" to the kernel driver.
  * nvme-cli: id-ctrl: Fix memory leak for JSON.
  * nvme-cli: id-ns: Fix memory leak for JSON.
  * nvme-cli: error-log: Fix memory leak for JSON.
  * nvme-cli: resv-report: Fix memory leak.
  * nvme-cli: smart-log: Fix memory leak for JSON.
  * nvme-cli: fw-log: Fix memory leak for JSON.
  * nvme-cli: json_add_smart_log(): Fix memory leak for JSON.
  * nvme-cli: smart-log: Allow negative values for temp sensors.
  * Don't print unimplemented sensor
  * Build without uuid
  * get-ns-id: Exit when no device provided.
  * nvme-cli: id-ctrl: Add vendor fields in JSON id-ctrl.
  * nvme-cli: nvme.c: Allow plug-ins to access to output formats and helper.
  * nvme-cli: Western Digital/HGST plug-in.
  * nvme-cli: Western Digital/HGST plug-in documentation.
  * <linux/nvme.h>: Correct NVMF enum values to match NVMe-oF rev 1.0
  * fabrics: Handle space-padded TRSVCID and TRADDR fields
  * nvme-cli: bug-fix: use right file name for perror.
  * move show_intel_smart_log to intel-nvme.c
  * remove json_add_smart_log
  * remove nvme_intel_smart_log
  * move struct nvme_additional_smart_log to intel-nvme.c
  * nvme-cli/format: use existing LBAF if none requested
  * nvme-cli: Release v1.2
* Thu Mar  2 2017 jthumshirn@suse.com
-  Update to upstream release v1.1 (FATE#322735)
  * This fixes multiple compiler warnings for 32-bit and other environments
    from v1.0, adds more documentation to fabrics, removes the libudev
    dependency entirely from this project, adds a framework for unit testing
    devices, and fixes usage for user defined install paths
* Thu Sep 15 2016 jthumshirn@suse.com
- Update to upstream release v0.9
  - Remove merged remove-version-from-list.patch
  * New extensions, fabrics support, a bug fixes. The 'list' command
    is liberated from its udev dependency, and no longer requires
    CONFIG_IO_STRICT_DEVMEM be disabled.
* Wed Aug 31 2016 jthumshirn@suse.com
- Don't map controller registers in 'list' command (boo#986891)
  + remove-version-from-list.patch
* Tue Aug  9 2016 jthumshirn@suse.com
- Update to upstream release v0.8
  - Remove merged patch 0001-bash-completion-Remove-shebang-line.patch
  * Code re-organized to support new extensions. While these are called
    "plugins", they currently have to be built into the executable. Support
    for dynamically loadable plugins is under consideration.
  * LightNVM is added as a built-in plugin.
  * Intel vendor specific commands and structure decodings are supported
    in a new intel plugin.
  * Support for NVMe-over-Fabrics
  * New output format "json" for a subset of commands that decode returned
    structures.
  * Lots of various documentation and minor code fixes.
* Wed Jun  1 2016 jthumshirn@suse.com
- Update to upstream release v0.7
  + 0001-bash-completion-Remove-shebang-line.patch
  Keith writes:
    Just a few minor updates and documentation fixes. There is also a new
    option for passthrough commands that can be used to help detect data
    over/under run.
    Tagging a stable release so we can consider features that bring in other
    transports and third party extensions.
* Wed Apr 13 2016 jthumshirn@suse.com
- Exclude build on s390x (FATE#319560)
* Fri Mar 18 2016 jthumshirn@suse.com
- Update to upstream release v0.5
    The v0.4 breakage should all be resolved now. Tagging release
    v0.5, and back to stability.
* Wed Mar  2 2016 jthumshirn@suse.com
- Update to upstream release v0.4
* Mon Feb 15 2016 jthumshirn@suse.com
- Fix display of version number (boo#966740)
* Thu Feb 11 2016 jthumshirn@suse.com
- Initial packaging for openSUSE
